import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.lang.Math;
/**
 * Write a description of class Blocker here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Blocker  extends Enemy
{
    private static final GreenfootImage[] blockImage = {
                            new GreenfootImage("images/enemy/blocker/blocker.png"),
                            new GreenfootImage("images/enemy/blocker/blocker2.png"),
                            new GreenfootImage("images/enemy/blocker/blocker3.png"),
                            new GreenfootImage("images/enemy/blocker/blocker4.png")
    };

    private static final GreenfootImage[] blockImageInvert = {
                            new GreenfootImage("images/enemy/blocker/blockerInvert.png"),
                            new GreenfootImage("images/enemy/blocker/blocker2Invert.png"),
                            new GreenfootImage("images/enemy/blocker/blocker3Invert.png"),
                            new GreenfootImage("images/enemy/blocker/blocker4Invert.png")
    };

    private int imageIndex;
    private static final int imageUpdateDelay = 16;
    private static final int moveUpdateDelay = 4;

    public Blocker(int x, int y){
        super(x,y);
        health = 80;
        getImage().setTransparency(0);
        imageIndex = 0;
        startX = x;
        startY = y;
    }

    public void reset(){
        health = 80;
        imageIndex = 0;
        setExactX(startX);
        setExactY(startY);
        active = false;
    }
    
    public void updateImage(){
        if(active){
            if(actTimer%imageUpdateDelay==0){
                imageIndex = (imageIndex+1)%blockImage.length;
            }
            if(invert){
                setImage(new GreenfootImage(blockImageInvert[imageIndex]));
            }else{
                setImage(new GreenfootImage(blockImage[imageIndex]));
            }
        }
    }

    public void move(){
        if(active){
            if(actTimer%moveUpdateDelay==0){
                setExactX(getExactX()-1);
            }
        }
    }
    /**
     * Act - do whatever the Blocker wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        actTimer = (actTimer+1)%100000;
        move();
        updateImage();
        if(actTimer%8==0){
            invert = false;    
        }
    }    
}
