import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Boss1 here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Boss1  extends Enemy
{
    private static final GreenfootImage[] blink = {
                          new GreenfootImage("images/enemy/boss1/bossEye/eye1.png"),                                    
                          new GreenfootImage("images/enemy/boss1/bossEye/eye2.png"),  
                          new GreenfootImage("images/enemy/boss1/bossEye/eye3.png"),  
                          new GreenfootImage("images/enemy/boss1/bossEye/eye4.png"),  
                          new GreenfootImage("images/enemy/boss1/bossEye/eye5.png"),  
                          new GreenfootImage("images/enemy/boss1/bossEye/eye6.png")  
                        };

    private Boss1Attack attack;
    private Boss1Part weakPoint;
    private Boss1Bullet[] bullet = {
                                    new Boss1Bullet(),
                                    new Boss1Bullet(),
                                    new Boss1Bullet()
                                };
                                    
    private static GreenfootSound[] shootSFX = new GreenfootSound[3];
    
    private int bulletIndex = 0;
    private int imageIndex;
    private boolean reverse;
    private int weakSpot;
    private static final int blinkSpeed = 3;
    private static final int shootSpeed = 250;
    private static final int vunerableSpeed = 300;

    public Boss1(int x, int y)
    {
        super(x,y);
        startX = x;
        startY = y;
        weakSpot = 0;
        imageIndex = 0;
        bulletIndex = 0;
        reverse = false;
        actTimer = 1;     
        try{
            shootSFX[0] = new GreenfootSound("sounds/boss1Attack.mp3");
            shootSFX[1] = new GreenfootSound("sounds/boss1Attack.mp3");
            shootSFX[2] = new GreenfootSound("sounds/boss1Attack.mp3");
        }catch(Exception e){}             
    }

    public void removeBullets(){
        for(int i=0; i<bullet.length; i++){
            if(bullet[i].getWorld() != null){
                getWorld().removeObject(bullet[i]);
            }
        }   
    }

    public void addBullets(){
        for(int i=0; i<bullet.length; i++){
            if(bullet[i].getWorld() == null){
                getWorld().addObject(bullet[i],0,0);
                bullet[i].setActive(false);
                bullet[i].getImage().setTransparency(0);
            }
        }              
    }
    
    public void reset(){
        active = false;
        weakSpot = 0;
        imageIndex = 0;
        bulletIndex = 0;
        reverse = false;
        actTimer = 1; 
        for(int i=0; i<bullet.length; i++){
            bullet[i].setLocation(getX(), getY());
            bullet[i].setActive(false);
        }   
    }
    
    public void addedToWorld(World world){
        attack = new Boss1Attack();
        weakPoint = new Boss1Part();
        addBullets();
        weakPoint.setActive(false);
        weakPoint.getImage().setTransparency(0);
        world.addObject(weakPoint,0,0);
        actTimer = 1;
    }

    private void shoot(){
        if((actTimer+60)%shootSpeed==0){            //fire bullet at this frequency
            if(bullet[bulletIndex].getActive()==false){
                Player p = ((Player)getWorld().getObjects(Player.class).get(0));
                attack.fireBullet(this, p, bullet[bulletIndex], 0);
                try{shootSFX[0].play();}catch(Exception exception){}
            }
            bulletIndex = (bulletIndex+1)%bullet.length;
        }
        if((actTimer+30)%shootSpeed==0){            //fire bullet at this frequency
            if(bullet[bulletIndex].getActive()==false){
                Player p = ((Player)getWorld().getObjects(Player.class).get(0));
                attack.fireBullet(this, p, bullet[bulletIndex], 1);
                try{shootSFX[1].play();}catch(Exception exception){}                
            }
            bulletIndex = (bulletIndex+1)%bullet.length;
        }
        if(actTimer%shootSpeed==0){            //fire bullet at this frequency
            if(bullet[bulletIndex].getActive()==false){
                Player p = ((Player)getWorld().getObjects(Player.class).get(0));
                attack.fireBullet(this, p, bullet[bulletIndex], 2);
                try{shootSFX[2].play();}catch(Exception exception){}                
            }
            bulletIndex = (bulletIndex+1)%bullet.length;
        }
    }

    private void revealWeakPoint(){
        if(actTimer%vunerableSpeed==0){
            if(weakSpot == 0)
                weakPoint.prepare(128,98,weakSpot);
            else if(weakSpot == 1){
                weakPoint.prepare(167,67,weakSpot);
            }else{
                weakPoint.prepare(88,67,weakSpot);
            }
            weakSpot = (weakSpot+1)%3;
        }
    }

    private void updateImage(){
        setImage(new GreenfootImage(blink[imageIndex]));
        if(reverse){
            imageIndex = imageIndex-1;
            if(imageIndex-1 < 0)
                reverse = false;
        }else{
            imageIndex = imageIndex+1;
            if(imageIndex+1 >= blink.length)
                reverse = true;
        }

    }

    /**
     * Act - do whatever the Boss1 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        actTimer = (actTimer + 1)%100000;
        if(actTimer%blinkSpeed == 0){   //update image at this frequency
            updateImage();
        }
        shoot();
        revealWeakPoint();
        addBullets();
        if (weakPoint.getWorld() == null)
        {
            for (int i = 0; i < bullet.length; i++){
                getWorld().removeObject(bullet[i]);
            }
            kill();


        }
    }    
}
