import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Boss1Part here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Boss1Part  extends Enemy
{
    private static final GreenfootImage[] dir = {
                                                new GreenfootImage("images/enemy/boss1/weakSpot.png"),
                                                new GreenfootImage("images/enemy/boss1/weakSpotLeft.png"),
                                                new GreenfootImage("images/enemy/boss1/weakSpotRight.png")
                                                };
                                                
    private static final GreenfootImage[] dirInvert = {
                                                new GreenfootImage("images/enemy/boss1/weakSpotInvert.png"),
                                                new GreenfootImage("images/enemy/boss1/weakSpotLeftInvert.png"),
                                                new GreenfootImage("images/enemy/boss1/weakSpotRightInvert.png")
                                                };                                                

    private boolean reverse;
    private boolean move;
    private int type;
    private double startX;
    private double startY;
    private int distMove = dir[0].getWidth();
    private static final int delayAmount = 40;
    private int delay;
    private boolean bossCalled;

    public Boss1Part()
    {
        super(0,0);
        health = 50;
        startX = 0;
        startY = 0;
        setExactX(0);
        setExactY(0);        
        reverse = false;
        invert = false;
        delay = delayAmount;
        active = false;
        dx = 0.5;
        dy = 0.5;
        type = 0;   //0 down, 1 left, 2 right
        getImage().setTransparency(0);
        actTimer = 1;
        bossCalled = false;
    }

    public void reset(){
        health = 50;        
        reverse = false;
        delay = delayAmount;
        active = false;
        invert = false;
        dx = 0.5;
        dy = 0.5;
        type = 0;   //0 down, 1 left, 2 right
        getImage().setTransparency(0);
        actTimer = 1;
        bossCalled = false;        
    }
    
    public void prepare(double x, double y, int t){
        startX = x;
        startY = y;
        setExactX(x);
        setExactY(y);
        invert = false;
        active = true;
        reverse = false;
        delay = delayAmount;
        getImage().setTransparency(255);
        type = t;
        bossCalled = true;
    }
    
    public void moveDown()
    {
        if(active){
            if(reverse){
                if(delay>0){
                    delay--;
                }else{
                    if(getExactY() > startY){
                        setExactY(getExactY()-getDy());
                    }else{
                        getImage().setTransparency(0);
                        active = false;
                    }
                }
            }else{
                setExactY(getExactY()+getDy());
                if(getExactY() > (startY+distMove))
                    reverse = true;
            }
        }
    }

    public void moveLeft()
    {
        if(active){
            if(reverse){
                if(delay>0){
                    delay--;
                }else{
                    if(getExactX() < startX){
                        setExactX(getExactX()+getDx());
                    }else{
                        getImage().setTransparency(0);
                        active = false;
                    }
                }
            }else{
                setExactX(getExactX()-getDx());
                if(getExactX() < (startX-distMove))
                    reverse = true;
            }
        }
    }

    public void moveRight()
    {
        if(active){
            if(reverse){
                if(delay>0){
                    delay--;
                }else{
                    if(getExactX() > startX){
                        setExactX(getExactX()-getDx());
                    }else{
                        getImage().setTransparency(0);
                        active = false;
                    }
                }
            }else{
                setExactX(getExactX()+getDx());
                if(getExactX() > (startX+distMove))
                    reverse = true;
            }
        }
    }

    public void act() 
    {
        actTimer = (actTimer + 1)%100000;
        if(active && bossCalled){
            setLocation((int)Math.round(getExactX()), (int)Math.round(getExactY()));
            switch(type){
                case 1:
                    if(invert){
                        setImage(new GreenfootImage(dirInvert[2]));                        
                    }else{
                        setImage(new GreenfootImage(dir[2]));                        
                    }

                    distMove = getImage().getWidth();
                    moveRight();
                    break;

                case 2:
                    if(invert){
                        setImage(new GreenfootImage(dirInvert[1]));                                                
                    }else{
                        setImage(new GreenfootImage(dir[1]));                        
                    }

                    distMove = getImage().getWidth();
                    moveLeft();
                    break;

                default:
                    if(invert){
                        setImage(new GreenfootImage(dirInvert[0]));                                            
                    }else{
                        setImage(new GreenfootImage(dir[0]));                    
                    }

                    distMove = getImage().getHeight();
                    moveDown();
                    break;
            }
        }
        
        if(actTimer%8==0){
            invert = false;    
        }

    }  
}
