import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class PlayerBullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PlayerBullet  extends Bullet
{
    private boolean hitWall;
    private static final int damage = 1;
    private static final GreenfootImage[] wallBurst = {
                                    new GreenfootImage("images/player/shot/shot.png"),          
                                    new GreenfootImage("images/player/shot/wallBurst1.png"),  
                                    new GreenfootImage("images/player/shot/wallBurst2.png")                                      
    };
    private static final GreenfootImage[] wideShot = {
                                    new GreenfootImage("images/player/shot/strongShotLeft.png"),
                                    new GreenfootImage("images/player/shot/strongShotRight.png"),
                                    new GreenfootImage("images/player/shot/strongShotUp.png"),
                                    new GreenfootImage("images/player/shot/strongShotDown.png")
    };

    private int wallBurstIndex;
    private boolean strongType;

    
    public PlayerBullet()
    {
        super(0,0);
        speed = 10;
        strongType = false;
        hitWall = false;
        wallBurstIndex = 0;
    }
    
    private void specialBehavior(Enemy e){
            e.setInvert(true);
    }

    private boolean ignoreHit(Enemy e){
        if(e instanceof Boss1){
            return true;
        }
        if(e instanceof Boss1Overlay){
            return true;
        }        
        return false;
    }
    
    private void checkEnemyHit(){
        List l = getWorld().getObjects(Enemy.class);
        Enemy e;
        for(int i=0; i<l.size(); i++){
            e = (Enemy)l.get(i);
            if(this.intersects(e) && e.getActive()){
                specialBehavior(e);
                if(!ignoreHit(e)){
                    if(!strongType){
                        e.setHealth(e.getHealth()-damage);
                    }else{
                        e.setHealth(e.getHealth()-damage*2);
                    }
                    if(e.getHealth() <= 0){
                        e.kill();
                    }else{
                        ((MusicController)getWorld().getObjects(MusicController.class).get(0)).playHitEnemy();
                            hitWall = true;                 
                    }
                }else{
                    //do nothing        
                }
            }
        }
    }

    private void wallBurst(){
        if(wallBurstIndex < wallBurst.length){
            if(actTimer%2==0){
                setImage(new GreenfootImage(wallBurst[wallBurstIndex]));
                wallBurstIndex++;
            }
        }else{
            wallBurstIndex = 0;
            hitWall = false;
            setImage(new GreenfootImage(wallBurst[0]));            
            setActive(false);
            getImage().setTransparency(0);
            return; 
        }
    }
    
    public void setImageState(int state, boolean strong){
        strongType = strong;
        if(strong){ //wide bullet has direction
            switch(state){
                case State.LEFT:
                    setImage(new GreenfootImage(wideShot[0]));
                    break;

                case State.RIGHT:
                    setImage(new GreenfootImage(wideShot[1]));
                    break;

                case State.UP:
                    setImage(new GreenfootImage(wideShot[2]));
                    break;

                default:
                    setImage(new GreenfootImage(wideShot[3]));      //down
                    break;
            }
        }else{      //normal bullet does not
                    setImage(new GreenfootImage(wallBurst[0]));
        }

    }

    /**
     * Act - do whatever the PlayerBullet wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        actTimer = (actTimer+1)%10000;
        if(hitWall){
            wallBurst();
        }else if(active){
            checkEnemyHit();
            Player p = ((Player)getWorld().getObjects(Player.class).get(0));
            WorldStats stats = ((WorldStats)getWorld().getObjects(WorldStats.class).get(0));
            GreenfootImage bgLogic = stats.getCurrentLevel().getCurrentLogicalImage(stats.getSection());
            
            setExactX(getExactX()+getDx());
            setExactY(getExactY()+getDy());
            setLocation((int)Math.round((p.getX()+getExactX()-p.getExactX())),(int)Math.round(p.getY()+getExactY()-p.getExactY()));
            
            int x = (int)Math.round(getExactX());   
            int y = (int)Math.round(getExactY());     
            
            if(getX() >= getWorld().getWidth() || getX() <= 0 || x < 0 || x >= bgLogic.getWidth()){
                setActive(false);
                getImage().setTransparency(0);
                return;
            }
            if(getY() >= getWorld().getHeight() || getY() <= 0 || y<0 || y >= bgLogic.getHeight()){
                setActive(false);
                getImage().setTransparency(0);
                return;
            }
            
       
            if(!strongType){
                if(bgLogic.getColorAt(x,y).equals(Logic.SOLID)){
                    hitWall = true;
                }
                if(bgLogic.getColorAt(x,y).equals(Logic.ONE_WAY_DOWN)){
                    hitWall = true;
                }
            }
            if(bgLogic.getColorAt(x,y).equals(Logic.SOLID_NO_PIERCE)){
                hitWall = true;
            }
            
        }
    }       
}
