import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Shooter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Shooter  extends Enemy
{
    private static final GreenfootImage[] shooterImage = {
                            new GreenfootImage("images/enemy/shooter/shoot1.png"),
                            new GreenfootImage("images/enemy/shooter/shoot2.png"),
                            new GreenfootImage("images/enemy/shooter/shoot3.png"),
                            new GreenfootImage("images/enemy/shooter/shoot4.png"),
                            new GreenfootImage("images/enemy/shooter/shoot5.png"),
                            new GreenfootImage("images/enemy/shooter/shoot6.png")
    };

    private static final GreenfootImage[] shooterImageInvert = {
                            new GreenfootImage("images/enemy/shooter/shoot1Invert.png"),
                            new GreenfootImage("images/enemy/shooter/shoot2Invert.png"),
                            new GreenfootImage("images/enemy/shooter/shoot3Invert.png"),
                            new GreenfootImage("images/enemy/shooter/shoot4Invert.png"),
                            new GreenfootImage("images/enemy/shooter/shoot5Invert.png"),
                            new GreenfootImage("images/enemy/shooter/shoot6Invert.png")
    };

    private static GreenfootSound fire;
    private int imageIndex;
    private ShooterBullet bullet = new ShooterBullet();
    private boolean type;
    private static final int attackSpeed = 120;
    private static final int imageUpdateSpeed = 5;

    public Shooter(int x, int y, boolean flip)
    {
        super(x,y);
        imageIndex = 0;
        actTimer = 1;
        type = flip;
        health = 10;
        bullet.setExactX(x);
        bullet.setExactY(y);
        try{fire = new GreenfootSound("sounds/shooterAttack.mp3");}catch(Exception e){}
    }

    public void reset(){
        actTimer = 1;
        health = 10;
        active = false;
        imageIndex = 0;
    }
    
    public void removeBullet(){
        if(bullet.getWorld() != null){
            getWorld().removeObject(bullet);
        }
    }
    
    public ShooterBullet getBullet(){
        return bullet;    
    }

    public void addBullet(){
        if(bullet.getWorld() == null){
            getWorld().addObject(bullet,0,0);
            bullet.setActive(false);
            bullet.getImage().setTransparency(0);
        }
    }

    public void addedToWorld(World world){
        addBullet();
    }

    public void updateImage(){
        if(active){
                if(invert){
                    setImage(new GreenfootImage(shooterImageInvert[imageIndex]));
                }else{
                    setImage(new GreenfootImage(shooterImage[imageIndex]));
                }
                if(type){
                    getImage().mirrorVertically();
                }
        }
    }

    public void turn(){
        if(!active)
            return;
    
        if(actTimer%imageUpdateSpeed!=0)
            return;

        Player p = ((Player)getWorld().getObjects(Player.class).get(0));
        if(p.getExactX() > getExactX()){
            if(imageIndex < shooterImage.length-1){
                imageIndex++;
            }
        }else if(p.getExactX() < getExactX()){
            if(imageIndex > 0){
                imageIndex--;
            }
        }else{
            if(imageIndex != shooterImage.length/2){
                if(imageIndex < shooterImage.length/2){
                    imageIndex++;
                }else{
                    imageIndex--;
                }
            }

        }
    }

    public void shoot(){
        if(active){
            if(actTimer%attackSpeed==0){
                if(bullet.getActive()==false){
                    if(imageIndex<shooterImage.length/2){   //facing left
                        bullet.setRight(false);
                    }else{      //facing right
                        bullet.setRight(true);
                    }
                    bullet.setExactX(getExactX());
                    bullet.setExactY(getExactY());
                    bullet.setLocation(getX(),getY());
                    bullet.setActive(true);
                    try{fire.play();}catch(Exception e){}
                }
            }
        }
    }

    /**
     * Act - do whatever the Shooter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        actTimer = (actTimer+1)%100000;
        turn();
        updateImage();
        addBullet();
        shoot();
        if(actTimer%8==0){
            invert = false;    
        }
    }    
}
