import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ShooterBullet here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ShooterBullet  extends Bullet
{
    private static final GreenfootImage[] fireShot = {
                    new GreenfootImage("images/enemy/shooter/shooterShot1.png"),
                    new GreenfootImage("images/enemy/shooter/shooterShot2.png")
    };
    private int fireShotIndex;
    private static final int imageUpdateSpeed = 3;
    private boolean right;
    private boolean parentDead;
    public ShooterBullet(){
        super(0,0);
        speed = 3;
        active = false;
        parentDead = false;
        fireShotIndex = 0;
        right = false;      //false for left, true for right
    }

    public void move(){
        if(active){
            if(right){
                setExactX(getExactX()+speed);
            }else{
                setExactX(getExactX()-speed);
            }
        }
    }

    private void updateImage(){
        if(active){
            setImage(new GreenfootImage(fireShot[fireShotIndex]));
            if(!right){
                getImage().mirrorHorizontally();
            }
            fireShotIndex = (fireShotIndex+1)%fireShot.length;
        }
    }

    /**
     * Act - do whatever the ShooterBullet wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        actTimer = (actTimer+1)%10000;
        move();
        updateImage();
    }    
    public boolean getParentDead(){
        return parentDead;
    }
    public void setParentDead(boolean b){
        parentDead = b;
    }
    
    public void setRight(boolean b){ 
        right = b;
    }
    public boolean getRight(){
        return right;
    }
}
