import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Spinner here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Spinner  extends Enemy
{
    private static final int imageUpdateSpeed = 4;
    private SpinnerPattern pattern;
    private boolean[] state;
    private int imageIndex;
    private boolean clockwise;
    private int direction;
    
    private static final GreenfootImage[] spinImage = {
                          new GreenfootImage("images/enemy/spinner/spinner1.png"),
                          new GreenfootImage("images/enemy/spinner/spinner2.png"),                          
                          new GreenfootImage("images/enemy/spinner/spinner3.png"),                          
                          new GreenfootImage("images/enemy/spinner/spinner4.png")
                                                 };

    public Spinner(int x, int y, boolean b){
        super(x,y);
        health = 1;
        startX = x;
        startY = y;
        state = new boolean[4];
        clockwise = b;
        dx = 2.0;
        dy = 2.0;
        imageIndex = 0;
        direction = Direction.LEFT;
        pattern = new SpinnerPattern();
        active = false;
    }
    
    public void reset(){
        active = false;
        initializeSpinnerState();
    }

    public void setState(int s, boolean b){
        state[s] = b;
    }
    public boolean getState(int s){
        return state[s];
    }     
    public int getDirection(){
        return direction;
    }
    public void setDirection(int d){
        direction = d;
    }
    public boolean getClockwise(){
        return clockwise;
    }
    public void setClockwise(boolean b){
        clockwise = b;
    }

    public void initializeSpinnerState(){
        health = 1;
        setExactX(startX);
        setExactY(startY);
        direction = Direction.LEFT;
        state[SpinnerState.GROUND] = false;
        state[SpinnerState.CEILING] = false;
        state[SpinnerState.RWALL] = false;
        state[SpinnerState.LWALL] = false;
    }

    private void printState(){
        System.out.println("Ground: "+state[SpinnerState.GROUND]);
        System.out.println("Ceiling: "+state[SpinnerState.CEILING]);
        System.out.println("Lwall: "+state[SpinnerState.LWALL]);
        System.out.println("Rwall: "+state[SpinnerState.RWALL]);
        System.out.println("Direction: "+Direction.print(direction));
        System.out.println("");
    }
    
    private void updateImage(){
        if(!active){
            return;
        }
        if(actTimer%imageUpdateSpeed == 0){
            setImage(new GreenfootImage(spinImage[imageIndex]));
            imageIndex = (imageIndex + 1)%spinImage.length;
        }
    }    
    
    public void act() 
    {
        actTimer = (actTimer + 1)%100000;
        if(active){
            updateImage();
            pattern.updateSpinner(state,this);
            //printState();
        }
    }    
}
