/**
 * Write a description of class SpinnerPattern here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class SpinnerPattern  extends MoveBehavior 
{
    public SpinnerPattern()
    {
        super(1);
    }

    public boolean[] updateSpinner(boolean[] state, Spinner s)
    {
        if(noWall(state)){  //spinner not touching a wall
            changeOffWall(state, s);
        }else{              //spinner is touching a wall
            changeOnWall(state,s);            
        }
        move(s);
        return state;
    }

    private void move(Spinner s){
        switch(s.getDirection()){
            case Direction.LEFT:
                s.setExactX(s.getExactX()-s.getDx());
                break;
            case Direction.RIGHT:
                s.setExactX(s.getExactX()+s.getDx());
                break;
            case Direction.UP:
                s.setExactY(s.getExactY()-s.getDy());
                break;
            case Direction.DOWN:
                s.setExactY(s.getExactY()+s.getDy());
                break;

            default:
                System.out.println("?");
                break;
        }
    }

    private boolean noWall(boolean[] state){
        return (!state[SpinnerState.GROUND] && 
                !state[SpinnerState.CEILING] && 
                !state[SpinnerState.LWALL] && 
                !state[SpinnerState.RWALL]);
    }

    private void changeOnWall(boolean[] state, Spinner s){      //change direction on wall collision
        if(s.getClockwise()){               //spinner moves clockwise
            if(state[SpinnerState.GROUND]){
                if(state[SpinnerState.LWALL]){
                    s.setDirection(Direction.UP);
                }else{
                    s.setDirection(Direction.LEFT);
                }
            }else if(state[SpinnerState.CEILING]){
                if(state[SpinnerState.RWALL]){
                    s.setDirection(Direction.DOWN);
                }else{
                    s.setDirection(Direction.RIGHT);
                }
            }else if(state[SpinnerState.RWALL]){
                if(state[SpinnerState.GROUND]){
                    s.setDirection(Direction.LEFT);
                }else{
                    s.setDirection(Direction.DOWN);
                }
            }else if(state[SpinnerState.LWALL]){
                if(state[SpinnerState.CEILING]){
                    s.setDirection(Direction.RIGHT);
                }else{
                    s.setDirection(Direction.UP);
                }
            }
        }else{                                      //spinner moves counterclockwise
            if(state[SpinnerState.GROUND]){
                if(state[SpinnerState.RWALL]){
                    s.setDirection(Direction.UP);
                }else{
                    s.setDirection(Direction.RIGHT);
                }
            }else if(state[SpinnerState.CEILING]){
                if(state[SpinnerState.LWALL]){
                    s.setDirection(Direction.DOWN);
                }else{
                    s.setDirection(Direction.LEFT);
                }
            }else if(state[SpinnerState.RWALL]){
                if(state[SpinnerState.CEILING]){
                    s.setDirection(Direction.LEFT);
                }else{
                    s.setDirection(Direction.UP);
                }
            }else if(state[SpinnerState.LWALL]){
                if(state[SpinnerState.GROUND]){
                    s.setDirection(Direction.RIGHT);
                }else{
                    s.setDirection(Direction.DOWN);
                }
            }
        }
    }

    private boolean[] changeOffWall(boolean[] state, Spinner s){     //change direction after moving into open space
        if(s.getClockwise()){
            switch(s.getDirection()){
                case Direction.LEFT:
                    s.setDirection(Direction.DOWN);
                    break;

                case Direction.RIGHT:
                    s.setDirection(Direction.UP);
                    break;

                case Direction.UP:
                    s.setDirection(Direction.LEFT);
                    break;

                case Direction.DOWN:
                    s.setDirection(Direction.RIGHT);
                    break;

                default:
                    break;
            }
        }else{  
            switch(s.getDirection()){
                case Direction.LEFT:
                    s.setDirection(Direction.UP);
                    break;

                case Direction.RIGHT:
                    s.setDirection(Direction.DOWN);
                    break;

                case Direction.UP:
                    s.setDirection(Direction.RIGHT);
                    break;

                case Direction.DOWN:
                    s.setDirection(Direction.LEFT);
                    break;

                default:
                    break;
            }
        }
        return state;
    }
}
