import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Walker here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Walker  extends Enemy
{
    private static final int imageUpdateSpeed = 5;
    private WalkerPattern pattern;
    private boolean[] state;
    private int imageIndex;
    private boolean type;
    
    private static final GreenfootImage empty =  new GreenfootImage("images/enemy/walker/walkEmpty.png");
    private static final GreenfootImage[] walkImage = {
                          new GreenfootImage("images/enemy/walker/walk1.png"),
                          new GreenfootImage("images/enemy/walker/walk2.png"),
                          new GreenfootImage("images/enemy/walker/walk3.png"),
                          new GreenfootImage("images/enemy/walker/walk4.png"),
                          new GreenfootImage("images/enemy/walker/walk5.png"),
                          new GreenfootImage("images/enemy/walker/walk6.png"),
                          new GreenfootImage("images/enemy/walker/walk7.png"),
                          new GreenfootImage("images/enemy/walker/walk8.png")                          
                                                 };    
    
    public Walker(int x, int y, boolean b)
    {
        super(x,y);
        health = 1;
        startX = x;
        startY = y;
        dx = 0.9;
        dy = 2.5;
        imageIndex = 0;
        state = new boolean[9];
        pattern = new WalkerPattern();
        setImage(empty);
        state[WalkerState.INVERTED] = b;   //true for normal gravity, false for inverted
        initializeWalkerState();
    }

    public void reset(){
        active = false;
        initializeWalkerState();
    }
    
    public void initializeWalkerState()
    {
        //player starts on the ground with no armor or powerups facing to the right    
        setExactX(startX);
        setExactY(startY);    
        setImage(empty);
        state[WalkerState.LEFT] = true;        
        state[WalkerState.RIGHT] = false;
        state[WalkerState.GROUND] = false;  
        state[WalkerState.CEILING] = false;             
        state[WalkerState.FLIP] = false;
        state[WalkerState.TURN] = false;
        state[WalkerState.FLIPPED] = false;                  
        state[WalkerState.CANFLIP] = true;
    }        
    
    public void setState(int s, boolean b){
        state[s] = b;
    }
    public boolean getState(int s){
        return state[s];
    }       
    
    public void printState(){
        System.out.println("Left: "+state[WalkerState.LEFT]);
        System.out.println("Right: "+state[WalkerState.RIGHT]);
        System.out.println("Ground: "+state[WalkerState.GROUND]);
        System.out.println("Flipped: "+state[WalkerState.FLIPPED]);
        System.out.println("Ceiling: "+state[WalkerState.CEILING]);
        System.out.println("Flip: "+state[WalkerState.FLIP]);
        System.out.println("Turn: "+state[WalkerState.TURN]);
        System.out.println("CanFlip: "+state[WalkerState.CANFLIP]);
        System.out.println("Inverted: "+state[WalkerState.INVERTED]);        
        System.out.println("");
    }
    
    private void updateImage(){
        setImage(new GreenfootImage(walkImage[imageIndex]));
        
        if(state[WalkerState.LEFT]){     //use normal image
            getImage().mirrorHorizontally();
        }
        
        if(state[WalkerState.FLIPPED]){
            getImage().mirrorVertically();
        }
        
        imageIndex = (imageIndex + 1)%walkImage.length;
    }
    
    /**
     * Act - do whatever the Walker wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        actTimer = (actTimer + 1)%100000;    
        state = pattern.updateWalker(state,this);     
        if(active){            
            if(actTimer%imageUpdateSpeed == 0){
                updateImage();
            }            
            if(actTimer%5 == 0){
                //printState();            
            }               
        }else{
            setImage(empty);                
        }
    }    
}
