/**
 * Write a description of class WalkerPattern here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class WalkerPattern  extends MoveBehavior 
{
    /**
     * The direction of the movement. LEFT, or RIGHT
     */
    private int direction;

    public WalkerPattern(int frequency, int dir)
    {
        super(frequency);
        direction = dir;
    }
    
    public WalkerPattern()
    {
        super(5);    
        direction = Direction.RIGHT;        
    }
    
    
   /**
   * Get the direction of movement
   * @return    UP, DOWN, LEFT, or RIGHT
   */    
    public int getDirection()
    {
        return direction;    
    }

   /**
   * Set the direction
   * @param dir     Use Direction.UP, Direction.DOWN, Direction.LEFT, or Direction.RIGHT
   */  
   public void setDirection(int dir)
   {
        if(dir != Direction.UP || dir != Direction.DOWN || dir != Direction.LEFT || dir != Direction.RIGHT){
            direction = Direction.LEFT;
        }else{
            direction = dir;    
        }
   }
    

   /**
   * Updates the x or y coordinates based on the direction of movement
   */      
    public boolean[] updateWalker(boolean[] state, Walker w)
    {
       if(state[WalkerState.TURN]){
           if(state[WalkerState.RIGHT]){
               state[WalkerState.LEFT] = true;               
               state[WalkerState.RIGHT] = false;
           }else if(state[WalkerState.LEFT]){
               state[WalkerState.LEFT] = false;               
               state[WalkerState.RIGHT] = true;
           }
           state[WalkerState.TURN] = false;
       }
       
       if(state[WalkerState.FLIP] && state[WalkerState.CANFLIP]){
           state[WalkerState.FLIPPED] = !state[WalkerState.FLIPPED];
           state[WalkerState.CANFLIP] = false;     
           state[WalkerState.FLIP] = false;
       }
       
          
       
       if((state[WalkerState.GROUND] && !state[WalkerState.FLIPPED])  || (state[WalkerState.CEILING] && state[WalkerState.FLIPPED]) ){      //grounded
           if(w.getActive()){
               if(state[WalkerState.LEFT]){
                   w.setExactX(w.getExactX()-w.getDx());
               }else if(state[WalkerState.RIGHT]){
                   w.setExactX(w.getExactX()+w.getDx());           
               }           
           }
       }else{
           if(!state[WalkerState.FLIPPED]){
               w.setExactY(w.getExactY()+w.getDy());
           }else{
               w.setExactY(w.getExactY()-w.getDy());                                        
           }             
       }
       
       return state;
    }
}
